DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Attributes | Private Member Functions | Private Attributes | List of all members
DiColorOutputPixelTemplate< T1, T2 > Class Template Reference

Template class to create color output data. More...

Inheritance diagram for DiColorOutputPixelTemplate< T1, T2 >:

## Public Member Functions
| DiColorOutputPixelTemplate (void *buffer, const DiColorPixel *pixel, const unsigned long count, const unsigned long frame, const int bits1, const int bits2, const int planar, const int inverse)
| constructor More...
| DiColorOutputPixelTemplate (void *buffer, const DiPixel *pixel, const unsigned long count, const unsigned long frame, const unsigned long, const int planar)
| constructor More...
virtual | ~DiColorOutputPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation More...
size_t | getItemSize () const
| get size of one pixel / item in the pixel array More...
const void * | getData () const
| get pointer to output pixel data More...
virtual void * | getDataPtr ()
| get pointer to output pixel data More...
const void * | getPlane (const int plane) const
| get pointer to given plane of output pixel data More...
int | writePPM (STD_NAMESPACE ostream &stream) const
| write pixel data of selected frame to PPM/ASCII file More...
int | writePPM (FILE *stream) const
| write pixel data of selected frame to PPM/ASCII file More...
Public Member Functions inherited from DiColorOutputPixel
| DiColorOutputPixel (const DiPixel *pixel, const unsigned long size, const unsigned long frame)
| constructor More...
virtual | ~DiColorOutputPixel ()
| destructor
unsigned long | getCount () const
| get number of pixel per frame More...
Public Member Functions inherited from DiPixelRepresentationTemplate< T2 >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not More...

## Protected Attributes
T2 * | Data
| pointer to the storage area where the output data should be stored
Protected Attributes inherited from DiColorOutputPixel
unsigned long | Count
| number of pixels per frame (intermediate representation)
const unsigned long | FrameSize
| number of pixels per frame (memory buffer size)

## Private Member Functions
void | convert (const T1 *pixel[3], const unsigned long start, const int bits1, const int bits2, const int planar, const int inverse)
| convert intermediate pixel data to output format (render pixel data) More...

## Private Attributes
int | DeleteData
| flag indicating whether the output data buffer should be deleted in the destructor
int | isPlanar
| flag indicating whether pixel data is stored color-by-pixel or color-by-plane

## Additional Inherited Members

## Detailed Description

### template<class T1, class T2>
class DiColorOutputPixelTemplate< T1, T2 >

Template class to create color output data.

## Constructor & Destructor Documentation

## ◆ DiColorOutputPixelTemplate() [1/2]

template<class T1 , class T2 >

DiColorOutputPixelTemplate< T1, T2 >::DiColorOutputPixelTemplate | ( | void * | buffer,
|  | const DiColorPixel * | pixel,
|  | const unsigned long | count,
|  | const unsigned long | frame,
|  | const int | bits1,
|  | const int | bits2,
|  | const int | planar,
|  | const int | inverse
| ) |  |
| inline

constructor

Parameters

  buffer | storage area for the output pixel data (optional, maybe NULL)
  pixel | pointer to intermediate pixel representation (color)
  count | number of pixels per frame
  frame | frame to be rendered
  bits1 | bit depth of input data (intermediate)
  bits2 | bit depth of output data
  planar | flag indicating whether data shall be stored color-by-pixel or color-by-plane
  inverse | invert pixel data if true (0/0/0 = white)

References DiColorOutputPixel::Count, DiColorOutputPixelTemplate< T1, T2 >::Data, and DiColorOutputPixel::FrameSize.

## ◆ DiColorOutputPixelTemplate() [2/2]

template<class T1 , class T2 >

DiColorOutputPixelTemplate< T1, T2 >::DiColorOutputPixelTemplate | ( | void * | buffer,
|  | const DiPixel * | pixel,
|  | const unsigned long | count,
|  | const unsigned long | frame,
|  | const unsigned long | ,
|  | const int | planar
| ) |  |
| inline

constructor

Parameters

  buffer | storage area for the output pixel data (optional, maybe NULL)
  pixel | pointer to intermediate pixel representation
  count | number of pixels per frame
  frame | frame to be rendered (#)param frames (total number of frames present in intermediate representation)
  planar | flag indicating whether data shall be stored color-by-pixel or color-by-plane

References DiColorOutputPixel::Count, DiColorOutputPixelTemplate< T1, T2 >::Data, and DiColorOutputPixel::FrameSize.

## Member Function Documentation

## ◆ convert()

template<class T1 , class T2 >

void DiColorOutputPixelTemplate< T1, T2 >::convert | ( | const T1 * | pixel[3],
|  | const unsigned long | start,
|  | const int | bits1,
|  | const int | bits2,
|  | const int | planar,
|  | const int | inverse
| ) |  |
| inline private

convert intermediate pixel data to output format (render pixel data)

Parameters

  pixel | pointer to intermediate pixel representation (color)
  start | offset to first pixel to be converted
  bits1 | bit depth of input data (intermediate)
  bits2 | bit depth of output data
  planar | flag indicating whether data shall be stored color-by-pixel or color-by-plane
  inverse | invert pixel data if true (0/0/0 = white)

References DiColorOutputPixelTemplate< T1, T2 >::Data, and DiColorOutputPixel::FrameSize.

## ◆ getData()

template<class T1 , class T2 >

const void* DiColorOutputPixelTemplate< T1, T2 >::getData | ( |  | ) | const
| inline virtual

get pointer to output pixel data

Returns
  pointer to pixel data

Implements DiColorOutputPixel.

## ◆ getDataPtr()

template<class T1 , class T2 >

virtual void* DiColorOutputPixelTemplate< T1, T2 >::getDataPtr | ( |  | ) |
| inline virtual

get pointer to output pixel data

Returns
  pointer to pixel data

Implements DiColorOutputPixel.

## ◆ getItemSize()

template<class T1 , class T2 >

size_t DiColorOutputPixelTemplate< T1, T2 >::getItemSize | ( |  | ) | const
| inline virtual

get size of one pixel / item in the pixel array

Returns
  item size

Implements DiColorOutputPixel.

## ◆ getPlane()

template<class T1 , class T2 >

const void* DiColorOutputPixelTemplate< T1, T2 >::getPlane | ( | const int | plane | ) | const
| inline virtual

get pointer to given plane of output pixel data

Parameters

  plane | number of the plane to be retrieved (0..2)

Returns
  pointer to beginning of plane if successful, NULL otherwise

Implements DiColorOutputPixel.

References DiColorOutputPixelTemplate< T1, T2 >::Data.

## ◆ getRepresentation()

template<class T1 , class T2 >

EP_Representation DiColorOutputPixelTemplate< T1, T2 >::getRepresentation | ( |  | ) | const
| inline virtual

get integer representation

Returns
  integer representation

Implements DiColorOutputPixel.

References DiPixelRepresentationTemplate< T >::getRepresentation().

## ◆ writePPM() [1/2]

template<class T1 , class T2 >

int DiColorOutputPixelTemplate< T1, T2 >::writePPM | ( | FILE * | stream | ) | const
| inline virtual

write pixel data of selected frame to PPM/ASCII file

Parameters

  stream | open C file stream

Returns
  status, true if successful, false otherwise

Implements DiColorOutputPixel.

References DiColorOutputPixelTemplate< T1, T2 >::Data, and DiColorOutputPixel::FrameSize.

## ◆ writePPM() [2/2]

template<class T1 , class T2 >

int DiColorOutputPixelTemplate< T1, T2 >::writePPM | ( | STD_NAMESPACE ostream & | stream | ) | const
| inline virtual

write pixel data of selected frame to PPM/ASCII file

Parameters

  stream | open C++ output stream

Returns
  status, true if successful, false otherwise

Implements DiColorOutputPixel.

References DiColorOutputPixelTemplate< T1, T2 >::Data, and DiColorOutputPixel::FrameSize.

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/dicoopxt.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1